; tabstop=8
;
;

	ORG	0B000H

	JP	EXT_DRIVE
	JP	EXT_LOAD

TRACKNUM:	DW	0000H	; gbNԍ
MAXTRACK:	DW	0000H	; IgbNԍ

;
; OthCuI
;
EXT_DRIVE:
	LD	A,91H
	OUT	(0D3H),A	; 8255 ̃[hݒ
	LD	A,0F7H
	OUT	(0B1H),A	; hCuOt

	LD	E,17H		; SET MODE
	CALL	EXT_SENDCMD
	LD	E,02H		; hCuD2̂2D[h
	CALL	EXT_SENDDATA

;
; Py[W̃f[^ = 1800H = 24sectors
; 10y[W̃f[^ = 240sectors  ŏIZN^ԍ239 ɂ
;

	LD	E,80H		; SET SECTOR DATA
	CALL	EXT_SENDCMD
	LD	E,01H		; hCuD2w
	CALL	EXT_SENDDATA
	LD	E,00H		; 擪ZN^ԍ=0
	CALL	EXT_SENDDATA
	LD	E,0EFH		; ŏIZN^ԍ=239
	CALL	EXT_SENDDATA

	RET


; OthCuւ̃R}hԍo
; Ereg : o͂R}h
; 
EXT_SENDCMD:
	LD	A,0FH
	OUT	(0D3H),A	; (PD)ATN rbgZbg

; OthCuւ̂PoCgf[^o
; Ereg : o͂f[^
; 
EXT_SENDDATA:
ESL1:	IN	A,(0D2H)
	AND	02H		; (DP)RFD rbgeXg
	JR	Z,ESL1		; RFD rbgZbg܂ő҂
	LD	A,0EH
	OUT	(0D3H),A	; ATN rbgZbg
	LD	A,E
	OUT	(0D1H),A	; f[^|[gBɏo
	LD	A,09H
	OUT	(0D3H),A	; (PD)DAV rbgZbg
ESL2:	IN	A,(0D2H)
	AND	04H		; (DP)DAC rbgeXg
	JR	Z,ESL2		; DAC rbgZbg܂ő҂
	LD	A,08H
	OUT	(0D3H),A	; (PD)DAV rbgZbg
ESL3:	IN	A,(0D2H)
	AND	04H		; (DP)DAC rbgeXg
	JR	NZ,ESL3		; DAC rbgZbg܂ő҂
	RET

; OthCûPoCgf[^M
; RETURN
; Ereg : Mf[^
; 
EXT_RCVDATA:
	LD	A,0BH
	OUT	(0D3H),A	; (PD)RFD rbgZbg
ERL1:	IN	A,(0D2H)
	AND	01H		; (DP)DAV rbgeXg
	JR	Z,ERL1		; DAV rbgZbg܂ő҂
	LD	A,0AH
	OUT	(0D3H),A	; (PD)RFD rbgZbg
	IN	A,(0D0H)	; |[gAf[^
	LD	E,A
	LD	A,0DH
	OUT	(0D3H),A	; (PD)DAC rbgZbg
ERL2:	IN	A,(0D2H)
	AND	01H		; (DP)DAV rbgeXg
	JR	NZ,ERL2		; DAV rbgZbg܂ő҂
	LD	A,0CH
	OUT	(0D3H),A	; (PD)DAC rbgZbg
	RET

;
; SDJ[hf[^ǂݏo
;
EXT_LOAD:

	LD	A,0F2H		; 0E000H-
	OUT	(0B0H),A

	LD	E,82H		; REPORT DISK IMAGE
	CALL	EXT_SENDCMD
	LD	E,01H		; hCuD2̃C[Wǂݏo
	CALL	EXT_SENDDATA
	CALL	EXT_RCVDATA
	LD	H,E
	CALL	EXT_RCVDATA
	LD	L,E
	CALL	EXT_RCVDATA
	LD	D,E
	CALL	EXT_RCVDATA

				; PgbN = F000H bytes

	OR	A
	RR	H		; t@Cۂ̃f[^̂Q{Ȃ̂ŁAQŊ
	RR	L
	RR	D


		;
		; t@CF000HŊ
		;
	LD	A,D
	LD	DE,0000H
	LD	BC,0000H
ELP1:
	SUB	0F0H
	SBC	HL,DE
	INC	BC
	JR	NC,ELP1
	DEC	BC


	LD	(MAXTRACK),BC

	LD	HL,0000H
	LD	(TRACKNUM),HL

	DI
ELL1:	CALL	LOADSUB
	LD	HL,(TRACKNUM)
	INC	HL
	LD	(TRACKNUM),HL
	EX	DE,HL
	LD	HL,(MAXTRACK)
	OR	A
	SBC	HL,DE
	JR	NZ,ELL1
	EI
	RET

; PgbNǂݏo
; 
; Pt[ = 256bytes ~ 24sectors
; PgbN = 240sectors = 10t[
;
LOADSUB:
	LD	E,85H		; EXPAND READ DATA
	CALL	EXT_SENDCMD
	LD	E,0F0H		; ǂݏoZN^
	CALL	EXT_SENDDATA
	LD	E,01H		; hCuD2I
	CALL	EXT_SENDDATA
	LD	HL,(TRACKNUM)
	LD	E,H		; gbNԍ
	CALL	EXT_SENDDATA
	LD	E,L		; gbNԍ
	CALL	EXT_SENDDATA
	LD	E,00H		; 擪ZN^ԍ
	CALL	EXT_SENDDATA

	LD	E,03H		; TRANSFER DATA
	CALL	EXT_SENDCMD

	LD	B,05H

LSL3:
	LD	HL,0C200H
LSL1:	CALL	EXT_RCVDATA
	LD	(HL),E
	INC	HL
	LD	A,H
	CP	0DAH
	JR	NZ,LSL1

	LD	A,0F0H		; 0C000H-
	OUT	(0B0H),A

	LD	HL,0E200H
LSL2:	CALL	EXT_RCVDATA
	LD	(HL),E
	INC	HL
	LD	A,H
	CP	0FAH
	JR	NZ,LSL2

	LD	A,0F2H		; 0E000H-
	OUT	(0B0H),A

	DJNZ	LSL3

	RET


	END
