; tabstop=8
;
;

	ORG	0D000H

	JP	EXT_DRIVE
	JP	EXT_LOAD

TRACKNUM:	DW	0000H	; gbNԍ
MAXTRACK:	DW	0000H	; IgbNԍ

;
; OthCuI
;
EXT_DRIVE:
	LD	A,91H
	OUT	(0D3H),A	; 8255 ̃[hݒ
	LD	A,0F7H
	OUT	(0B1H),A	; hCuOt

	LD	E,17H		; SET MODE
	CALL	EXT_SENDCMD
	LD	E,02H		; hCuD2̂2D[h
	CALL	EXT_SENDDATA

	LD	E,80H		; SET SECTOR DATA
	CALL	EXT_SENDCMD
	LD	E,01H		; hCuD2w
	CALL	EXT_SENDDATA
	LD	E,00H		; 擪ZN^ԍ=0
	CALL	EXT_SENDDATA
	LD	E,0FFH		; ŏIZN^ԍ=255
	CALL	EXT_SENDDATA

	RET


; OthCuւ̃R}hԍo
; Ereg : o͂R}h
; 
EXT_SENDCMD:
	LD	A,0FH
	OUT	(0D3H),A	; (PD)ATN rbgZbg

; OthCuւ̂PoCgf[^o
; Ereg : o͂f[^
; 
EXT_SENDDATA:
ESL1:	IN	A,(0D2H)
	AND	02H		; (DP)RFD rbgeXg
	JR	Z,ESL1		; RFD rbgZbg܂ő҂
	LD	A,0EH
	OUT	(0D3H),A	; ATN rbgZbg
	LD	A,E
	OUT	(0D1H),A	; f[^|[gBɏo
	LD	A,09H
	OUT	(0D3H),A	; (PD)DAV rbgZbg
ESL2:	IN	A,(0D2H)
	AND	04H		; (DP)DAC rbgeXg
	JR	Z,ESL2		; DAC rbgZbg܂ő҂
	LD	A,08H
	OUT	(0D3H),A	; (PD)DAV rbgZbg
ESL3:	IN	A,(0D2H)
	AND	04H		; (DP)DAC rbgeXg
	JR	NZ,ESL3		; DAC rbgZbg܂ő҂
	RET

; OthCûPoCgf[^M
; RETURN
; Ereg : Mf[^
; 
EXT_RCVDATA:
	LD	A,0BH
	OUT	(0D3H),A	; (PD)RFD rbgZbg
ERL1:	IN	A,(0D2H)
	AND	01H		; (DP)DAV rbgeXg
	JR	Z,ERL1		; DAV rbgZbg܂ő҂
	LD	A,0AH
	OUT	(0D3H),A	; (PD)RFD rbgZbg
	IN	A,(0D0H)	; |[gAf[^
	LD	E,A
	LD	A,0DH
	OUT	(0D3H),A	; (PD)DAC rbgZbg
ERL2:	IN	A,(0D2H)
	AND	01H		; (DP)DAV rbgeXg
	JR	NZ,ERL2		; DAV rbgZbg܂ő҂
	LD	A,0CH
	OUT	(0D3H),A	; (PD)DAC rbgZbg
	RET


; OthCûSoCgf[^M~US
; HLreg : data pointer
; 
EXT_RCV4DATA:
	LD	A,0BH
	OUT	(0D3H),A	; (PD)RFD rbgZbg
E4RL1:	IN	A,(0D2H)
	RRCA			; (DP)DAV rbgeXg
	JR	NC,E4RL1	; DAV rbgZbg܂ő҂
	LD	A,0AH
	OUT	(0D3H),A	; (PD)RFD rbgZbg

	LD	BC,00D0H	; 256񃋁[v/|[gA
E4RL3:	IN	A,(0D2H)
	RRCA			; (DP)DAV rbgeXg
	JR	NC,E4RL3	; DAV rbgZbg܂ő҂
	INI			; |[gA(0D0H)f[^
	INC	C
	INI			; |[gB(0D1H)f[^
	DEC	C
	LD	A,0DH
	OUT	(0D3H),A	; (PD)DAC rbgZbg
E4RL2:	IN	A,(0D2H)
	RRCA			; (DP)DAV rbgeXg
	JR	C,E4RL2		; DAV rbgZbg܂ő҂
	INI			; |[gA(0D0H)f[^
	INC	C
	INI			; |[gB(0D1H)f[^
	DEC	C
	LD	A,0CH
	OUT	(0D3H),A	; (PD)DAC rbgZbg
	LD	A,B
	OR	A
	JR	NZ,E4RL3

	RET


;
; SDJ[hf[^ǂݏo
;
EXT_LOAD:


	LD	A,0F6H		; 4000H-
	OUT	(0B0H),A

	LD	E,82H		; REPORT DISK IMAGE
	CALL	EXT_SENDCMD
	LD	E,01H		; hCuD2̃C[Wǂݏo
	CALL	EXT_SENDDATA
	CALL	EXT_RCVDATA
	LD	H,E
	CALL	EXT_RCVDATA
	LD	L,E
	CALL	EXT_RCVDATA
	CALL	EXT_RCVDATA
				; PgbN = 10000H bytes
	
	OR	A
	RR	H
	RR	L

	LD	(MAXTRACK),HL

	LD	HL,0000H
	LD	(TRACKNUM),HL

	DI
ELL1:	CALL	LOADSUB
	LD	HL,(TRACKNUM)
	INC	HL
	LD	(TRACKNUM),HL
	EX	DE,HL
	LD	HL,(MAXTRACK)
	OR	A
	SBC	HL,DE
	JR	NZ,ELL1
	EI
	RET

; PgbNǂݏo
; 
; Pt[ = 256bytes ~ 64sectors
; PgbN = 256sectors = St[
;
LOADSUB:
	LD	E,85H		; EXPAND READ DATA
	CALL	EXT_SENDCMD
	LD	E,0FFH		; ǂݏoZN^
	CALL	EXT_SENDDATA
	LD	E,01H		; hCuD2I
	CALL	EXT_SENDDATA
	LD	HL,(TRACKNUM)
	LD	E,H		; gbNԍ
	CALL	EXT_SENDDATA
	LD	E,L		; gbNԍ
	CALL	EXT_SENDDATA
	LD	E,00H		; 擪ZN^ԍ
	CALL	EXT_SENDDATA

	LD	E,88H		; FAST TRANSFER DATA
	CALL	EXT_SENDCMD

	LD	A,93H
	OUT	(0D3H),A	; 8255 ̃[hݒi|[g`F́^|[gaF́j

	LD	HL,0000H
LSL1:	CALL	EXT_RCV4DATA
	LD	A,H
	CP	40H
	JR	NZ,LSL1

	LD	A,0F4H		; 0000H-
	OUT	(0B0H),A

LSL2:	CALL	EXT_RCV4DATA
	LD	A,H
	CP	80H
	JR	NZ,LSL2

	LD	A,0F6H		; 4000H-
	OUT	(0B0H),A

	LD	HL,0000H
LSL3:	CALL	EXT_RCV4DATA
	LD	A,H
	CP	40H
	JR	NZ,LSL3

	LD	A,0F4H		; 0000H-
	OUT	(0B0H),A

LSL4:	CALL	EXT_RCV4DATA
	LD	A,H
	CP	7FH
	JR	NZ,LSL4

	LD	A,91H
	OUT	(0D3H),A	; 8255 ̃[hݒi|[g`F́^|[gaFój

	LD	A,0F6H		; 4000H-
	OUT	(0B0H),A

	RET


	END
